VirtualBox

source: vbox/trunk/configure@ 33000

Last change on this file since 33000 was 32176, checked in by vboxsync, 14 years ago

configure: added a check if 32-bit applications can be executed

  • Property svn:eol-style set to LF
  • Property svn:executable set to *
File size: 66.7 KB
Line 
1#!/bin/sh
2# The purpose of this script is to check for all external tools, headers, and
3# libraries VBox OSE depends on.
4
5#
6# Copyright (C) 2006-2009 Oracle Corporation
7#
8# This file is part of VirtualBox Open Source Edition (OSE), as
9# available from http://www.virtualbox.org. This file is free software;
10# you can redistribute it and/or modify it under the terms of the GNU
11# General Public License (GPL) as published by the Free Software
12# Foundation, in version 2 as it comes in the "COPYING" file of the
13# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
14# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
15#
16
17LC_ALL=C
18export LC_ALL
19
20# append some extra paths
21PATH="$PATH:/opt/gnome/bin"
22# Solaris (order of paths important for tr, echo, grep, sed to work)
23PATH="/usr/xpg4/bin:/usr/ucb:$PATH:/usr/local/bin:/usr/sfw/bin:/usr/ccs/bin"
24ORGPATH=$PATH
25
26# Wrapper for ancient /usr/bin/which on darwin that always returns 0
27which_wrapper()
28{
29 if [ -z "$have_ancient_which" ]; then
30 if which /bin/___cErTaINly_a_nOn_eXisTing_fIle___ 2> /dev/null > /dev/null; then
31 have_ancient_which="yes"
32 else
33 have_ancient_which="no"
34 fi
35 fi
36 if [ "$have_ancient_which" = "yes" ]; then
37 retval=`which $* 2>/dev/null`
38 echo "$retval"
39 test -n "$retval" -a -x "$retval"
40 unset retval
41 else
42 which $* 2> /dev/null
43 fi
44}
45
46OS=`uname -s | sed -e 's/GNU\/Linux/Linux/g' | tr [:upper:] [:lower:]`
47case "$OS" in
48 linux)
49 ;;
50 darwin)
51 ;;
52 freebsd)
53 ;;
54 sunos)
55 OS='solaris'
56 ;;
57 *)
58 echo "Cannot determine OS!"
59 exit 1
60 ;;
61esac
62
63#
64# Defaults
65#
66OSE=1
67ODIR="`pwd`/"
68ODIR_OVERRIDE=0
69OUT_PATH=""
70OUT_PATH_OVERRIDE=0
71SETUP_WINE=
72TARGET_MACHINE=""
73TARGET_CPU=""
74WITH_XPCOM=1
75WITH_PYTHON=1
76WITH_JAVA=1
77WITH_VMMRAW=1
78WITH_LIBIDL=1
79WITH_GSOAP=0
80WITH_QT4=1
81WITH_SDL=1
82WITH_SDL_TTF=1
83WITH_X11=1
84WITH_ALSA=1
85WITH_PULSE=1
86WITH_DBUS=1
87WITH_KMODS=1
88WITH_OPENGL=1
89WITH_HARDENING=1
90WITH_VDE=0
91WITH_DOCS=1
92BUILD_LIBXML2=
93BUILD_LIBXSLT=
94BUILD_LIBCURL=
95BUILD_LIBSSL=
96PASSIVE_MESA=0
97CC="gcc"
98CC32=""
99CC64=""
100CXX="g++"
101CXX32=""
102CXX64=""
103BCC="bcc"
104YASM="yasm"
105IASL="iasl"
106AS86="as86"
107XSLTPROC="xsltproc"
108GENISOIMAGE="genisoimage"
109MKISOFS="mkisofs"
110INCCRYPTO=""
111LIBCRYPTO="-lcrypto"
112LIBPTHREAD="-lpthread"
113LIBCAP="-lcap"
114GSOAP=""
115GSOAP_IMPORT=""
116INCX11="/usr/local/include"
117LIBX11="-L/usr/X11R6/lib -L/usr/X11R6/lib64 -L/usr/local/lib -lXext -lX11"
118LIBXCURSOR="-lXcursor"
119LIBXMU="-lXmu"
120LIBXINERAMA="-lXinerama"
121LIBXRANDR="-lXrandr"
122MAKESELF="makeself"
123MESA="-lGL"
124INCZ=""
125LIBZ="-lz"
126CXX_FLAGS=""
127if [ "$OS" = "freebsd" ]; then
128 INCCURL="-I/usr/local/include"
129 LIBCURL="-L/usr/local/lib -lcurl"
130 INCPULSE="-I/usr/local/include"
131 LIBPULSE="-L/usr/local/lib"
132 INCPNG="-I/usr/local/include"
133 LIBPNG="-L/usr/local/lib -lpng"
134else
135 INCCURL=""
136 LIBCURL="-lcurl"
137 INCPNG=""
138 LIBPNG="-lpng"
139fi
140PKGCONFIG="`which_wrapper pkg-config`"
141PYTHONDIR="/usr /usr/local"
142QT4DIR="/usr/lib/qt4 /usr/share/qt4 /usr/lib64/qt4 /usr /usr/local"
143QT4DIR_PKGCONFIG=1
144QT4UIC3DIR="/usr/bin"
145KBUILDDIR="`cd \`dirname $0\`; pwd`/kBuild"
146DEVDIR="`cd \`dirname $0\`; pwd`/tools"
147if [ -d "/lib/modules/`uname -r`/build" ]; then
148 LINUX="/lib/modules/`uname -r`/build"
149else
150 LINUX="/usr/src/linux"
151fi
152KCHMVIEWER="kchmviewer"
153LOG="configure.log"
154CNF="AutoConfig.kmk"
155ENV="env.sh"
156BUILD_TYPE="release"
157# the restricting tool is ar (mri mode).
158INVALID_CHARS="[^A-Za-z0-9/\\$:._-]"
159
160if (cd `dirname $0`; pwd)|grep -q "$INVALID_CHARS"; then
161 echo "Error: VBox base path contains invalid characters!"
162 exit 1
163fi
164
165# darwin /bin/sh has a builtin echo that doesn't grok -n. gotta love it.
166if [ "$OS" = "darwin" ]; then
167 ECHO_N="/bin/echo -n"
168else
169 ECHO_N="echo -n"
170fi
171
172
173cleanup()
174{
175 rm -f $ODIR.tmp_src.cc $ODIR.tmp_src.c $ODIR.tmp_out $ODIR.test_execute.log
176}
177
178fail()
179{
180 if [ -z "$nofatal" -o "x$1" != "x" ]; then
181 cleanup
182 rm -f $ENV
183 exit 1
184 fi
185}
186
187log()
188{
189 echo "$1"
190 echo "$1" >> $LOG
191}
192
193log_success()
194{
195 if [ -n "$1" ]; then $ECHO_N "$1, "; fi
196 echo "OK."
197 echo "$1" >> $LOG
198 echo >> $LOG
199 echo >> $LOG
200}
201
202log_failure()
203{
204 echo
205 echo " ** $1!"
206 echo "** $1!" >> $LOG
207 echo >> $LOG
208}
209
210cnf_append()
211{
212 printf "%-30s := %s\n" "$1" "$2" >> $CNF
213}
214
215strip_l()
216{
217 echo "$1"|$KBUILD_SED 's|-l\([^ ]\+\)|\1|g; s|^-[^l][^ ]*||g; s| -[^l][^ ]*||g; s|^ ||; s| *$||g'
218}
219
220strip_L()
221{
222 echo "$1"|$KBUILD_SED 's|-L\([^ ]\+\)|\1|g; s|^-[^L][^ ]*||g; s| -[^L][^ ]*||g; s|^ ||; s| *$||g'
223}
224
225strip_I()
226{
227 echo "$1"|$KBUILD_SED 's|-I\([^ ]\+\)|\1|g; s|^-[^I][^ ]*||g; s| -[^I][^ ]*||g; s|^ ||; s| *$||g'
228}
229
230prefix_I()
231{
232 echo "$1"|$KBUILD_SED 's|^\/|-I/|g; s| \/| -I/|g'
233}
234
235check_avail()
236{
237 if [ -z "$1" ]; then
238 log_failure "$2 is empty"
239 fail $3
240 return 1
241 elif which_wrapper $1 > /dev/null; then
242 return 0
243 else
244 log_failure "$1 (variable $2) not found"
245 fail $3
246 return 1
247 fi
248}
249
250
251# Prepare a test
252test_header()
253{
254 echo "***** Checking $1 *****" >> $LOG
255 $ECHO_N "Checking for $1: "
256}
257
258
259# Compile a test
260# $1 compile flags/libs
261# $2 library name
262# $3 package name
263# $4 if this argument is 'nofatal', don't abort
264test_compile()
265{
266 echo "compiling the following source file:" >> $LOG
267 cat $ODIR.tmp_src.cc >> $LOG
268 echo "using the following command line:" >> $LOG
269 echo "$CXX $CXX_FLAGS -g -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc \"$1\"" >> $LOG
270 $CXX $CXX_FLAGS -g -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc $1 >> $LOG 2>&1
271 if [ $? -ne 0 ]; then
272 if [ -z "$4" ]; then
273 echo
274 echo " $2 not found at $1 or $3 headers not found"
275 echo " Check the file $LOG for detailed error information."
276 fail
277 else
278 echo >> $LOG
279 echo >> $LOG
280 fi
281 return 1
282 fi
283 return 0
284}
285
286
287# Execute a compiled test binary
288test_execute()
289{
290 echo "executing the binary" >> $LOG
291 $ODIR.tmp_out > $ODIR.test_execute.log
292 rc=$?
293 cat $ODIR.test_execute.log | tee -a $LOG
294 if [ $rc -ne 0 ]; then
295 fail $1
296 return 1
297 fi
298 echo >> $LOG
299 echo >> $LOG
300 return 0
301}
302
303
304# Execute a compiled test binary
305test_execute_path()
306{
307 echo "executing the binary (LD_LIBRARY_PATH=$1)" >> $LOG
308 LD_LIBRARY_PATH=$1 $ODIR.tmp_out > $ODIR.test_execute.log
309 rc=$?
310 cat $ODIR.test_execute.log | tee -a $LOG
311 if [ $rc -ne 0 ]; then
312 fail
313 return 1
314 fi
315 echo >> $LOG
316 echo >> $LOG
317 return 0
318}
319
320
321#
322# Check for OS, MACHINE, CPU
323#
324check_environment()
325{
326 test_header environment
327 BUILD_CPU=`uname -m`
328 [ "$OS" = "solaris" ] && BUILD_CPU=`isainfo | cut -f 1 -d ' '`
329 case "$BUILD_CPU" in
330 i[3456789]86|x86|i86pc)
331 BUILD_MACHINE='x86'
332 LIB='lib'
333 ;;
334 x86_64|amd64)
335 BUILD_MACHINE='amd64'
336 BUILD_CPU='k8'
337 if [ "$OS" != "solaris" ]; then
338 # on AMD64 systems, 64bit libs are usually located in /usr/lib64
339 # see http://www.pathname.com/fhs/pub/fhs-2.3.html#LIB64
340 LIB='lib64'
341 else
342 # Solaris doesn't seem to subscribe to fhs, libs are usually in
343 # a '64' subdirectory of the standard 'lib' dirs while some 64-bit
344 # alternative binaries can be found in 'amd64' subdirs of the 'bin'
345 # ones. So, in order to find the right stuff (esp. sdl-config) we'll
346 # have to make sure the */bin/amd64 dirs are searched before the */bin
347 # ones. (The sed has some sideeffects, but they shouldn't harm us...)
348 echo "64-bit Solaris detected, hacking the PATH" >> $LOG
349 echo "old PATH: $PATH" >> $LOG
350 PATH=`echo ":$PATH:" | sed -e 's,\(:[^:]*/bin\):,\1/amd64:\1:,g' \
351 -e 's/^:*//' -e 's/:*$//g' -e 's/::*/:/g' `
352 export PATH
353 echo "new PATH: $PATH" >> $LOG
354 LIB='lib/64'
355 fi
356 ;;
357 *)
358 log_failure "Cannot determine system"
359 exit 1
360 ;;
361 esac
362 [ -z "$TARGET_MACHINE" ] && TARGET_MACHINE=$BUILD_MACHINE
363 [ -z "$TARGET_CPU" ] && TARGET_CPU=$BUILD_CPU
364 DEVDIR_BIN="$DEVDIR/$OS.$BUILD_MACHINE/bin"
365 log_success "Determined build machine: $OS.$BUILD_MACHINE, target machine: $OS.$TARGET_MACHINE"
366
367 echo "BUILD_PLATFORM=\"$OS\"" >> $ENV
368 echo "export BUILD_PLATFORM" >> $ENV
369 echo "BUILD_PLATFORM_ARCH=\"$BUILD_MACHINE\"" >> $ENV
370 echo "export BUILD_PLATFORM_ARCH" >> $ENV
371 echo "BUILD_TARGET=\"$OS\"" >> $ENV
372 echo "export BUILD_TARGET" >> $ENV
373 echo "BUILD_TARGET_ARCH=\"$TARGET_MACHINE\"" >> $ENV
374 echo "export BUILD_TARGET_ARCH" >> $ENV
375 echo "BUILD_TARGET_CPU=\"$TARGET_CPU\"" >> $ENV
376 echo "export BUILD_TARGET_CPU" >> $ENV
377 echo "BUILD_TYPE=\"$BUILD_TYPE\"" >> $ENV
378 echo "export BUILD_TYPE" >> $ENV
379}
380
381#
382# Check for gcc with version >= 3.2.
383# We depend on a working gcc, if we fail terminate in every case.
384#
385check_gcc()
386{
387 test_header gcc
388 if check_avail "$CC" CC really; then
389 cc_ver=`$CC -dumpversion` 2>/dev/null
390 if [ $? -ne 0 ]; then
391 log_failure "cannot execute '$CC -dumpversion'"
392 fail really
393 fi
394 if check_avail "$CXX" CXX really; then
395 cxx_ver=`$CXX -dumpversion` 2>/dev/null
396 if [ $? -ne 0 ]; then
397 log_failure "cannot execute '$CXX -dumpversion'"
398 fail really
399 fi
400 cc_maj=`echo $cc_ver|cut -d. -f1`
401 cc_min=`echo $cc_ver|cut -d. -f2`
402 if [ "x$cc_ver" != "x$cxx_ver" ]; then
403 log_failure "gcc version $cc_ver does not match g++ version $cxx_ver"
404 fail really
405 elif [ $cc_maj -eq 4 -a $cc_min -eq 0 -a "$OS" = "darwin" ]; then
406 log_success "found version $cc_ver"
407 # gcc-4.0 is allowed for Darwin only
408 elif [ $cc_maj -lt 3 \
409 -o \( $cc_maj -eq 3 -a $cc_min -lt 2 \) \
410 -o \( $cc_maj -eq 4 -a $cc_min -lt 1 -a "$OS" != "darwin" \) \
411 -o \( $cc_maj -eq 4 -a $cc_min -gt 5 \) \
412 -o $cc_maj -gt 4 ]; then
413 log_failure "gcc version $cc_ver found, expected gcc 3.x with x>1 or gcc 4.x with 0<x<5"
414 fail really
415 else
416 log_success "found version $cc_ver"
417 fi
418 if [ "$BUILD_MACHINE" = "amd64" ]; then
419 [ -z "$CC32" ] && CC32="$CC -m32"
420 [ -z "$CXX32" ] && CXX32="$CXX -m32"
421 else
422 [ -z "$CC32" ] && CC32="$CC"
423 [ -z "$CXX32" ] && CXX32="$CXX"
424 fi
425 if [ "$BUILD_MACHINE" = "x86" -a "$TARGET_MACHINE" = "amd64" ]; then
426 [ -z "$CC64" ] && CC64="$CC -m64"
427 [ -z "$CXX64" ] && CXX64="$CXX -m64"
428 fi
429 if [ "$TARGET_MACHINE" = "amd64" -a $WITH_VMMRAW -eq 0 ]; then
430 CC32="undefined"
431 CXX32="undefined"
432 fi
433 if [ "$CC" != "gcc" ]; then
434 cnf_append "TOOL_GCC3_CC" "$CC"
435 cnf_append "TOOL_GCC3_AS" "$CC"
436 cnf_append "TOOL_GCC3_LD" "$CC"
437 cnf_append "TOOL_GXX3_CC" "$CC"
438 cnf_append "TOOL_GXX3_AS" "$CC"
439 fi
440 if [ "$CXX" != "g++" ]; then
441 cnf_append "TOOL_GCC3_CXX" "$CXX"
442 cnf_append "TOOL_GXX3_CXX" "$CXX"
443 cnf_append "TOOL_GXX3_LD" "$CXX"
444 fi
445 if [ "$CC32" != "gcc -m32" -a "$CC32" != "undefined" ]; then
446 cnf_append "TOOL_GCC32_CC" "$CC32"
447 cnf_append "TOOL_GCC32_AS" "$CC32"
448 cnf_append "TOOL_GCC32_LD" "$CC32"
449 cnf_append "TOOL_GXX32_CC" "$CC32"
450 cnf_append "TOOL_GXX32_AS" "$CC32"
451 fi
452 if [ "$CXX32" != "g++ -m32" -a "$CXX32" != "undefined" ]; then
453 cnf_append "TOOL_GCC32_CXX" "$CXX32"
454 cnf_append "TOOL_GXX32_CXX" "$CXX32"
455 cnf_append "TOOL_GXX32_LD" "$CXX32"
456 fi
457 # this isn't not necessary, there is not such tool.
458 if [ -n "$CC64" ]; then
459 cnf_append "TOOL_GCC64_CC" "$CC64"
460 cnf_append "TOOL_GCC64_AS" "$CC64"
461 cnf_append "TOOL_GCC64_LD" "$CC64"
462 cnf_append "TOOL_GXX64_CC" "$CC64"
463 cnf_append "TOOL_GXX64_AS" "$CC64"
464 fi
465 if [ -n "$CXX64" ]; then
466 cnf_append "TOOL_GCC64_CXX" "$CXX64"
467 cnf_append "TOOL_GXX64_CXX" "$CXX64"
468 cnf_append "TOOL_GXX64_LD" "$CXX64"
469 fi
470 # Solaris sports a 32-bit gcc/g++.
471 if [ "$OS" = "solaris" -a "$BUILD_MACHINE" = "amd64" ]; then
472 [ "$CC" = "gcc" ] && CC="gcc -m64"
473 [ "$CXX" = "g++" ] && CXX="g++ -m64"
474 fi
475 fi
476 fi
477}
478
479
480#
481# Check for the bcc compiler, needed for compiling the BIOS
482#
483check_bcc()
484{
485 test_header bcc
486 if check_avail "$BCC" BCC; then
487 bcc_ver=`$BCC -v 2>&1|grep version|sed 's+^bcc: version \(.*\)+\1+'`
488 if [ $? -ne 0 ]; then
489 log_failure "not found"
490 fail
491 else
492 echo "compiling the following source file:" >> $LOG
493 cat > $ODIR.tmp_src.c << EOF
494int foo(a)
495 int a;
496{
497 return 0;
498}
499EOF
500 cat $ODIR.tmp_src.c >> $LOG
501 bcc_path=`which_wrapper $BCC`
502 bcc_dir="`dirname $bcc_path`/"
503 echo "using the following command line:" >> $LOG
504 echo "$BCC -B $bcc_dir -C-c -3 -S -o $ODIR.tmp_out $ODIR.tmp_src.c" >> $LOG
505 $BCC -B $bcc_dir -C-c -3 -S -o $ODIR.tmp_out $ODIR.tmp_src.c >> $LOG 2>&1
506 if [ $? -ne 0 ]; then
507 log_failure "not found"
508 fail
509 else
510 log_success "found version $bcc_ver"
511 cnf_append "VBOX_BCC" "$bcc_path -B $bcc_dir"
512 fi
513 unset bcc_path
514 unset bcc_dir
515 fi
516 fi
517}
518
519
520#
521# Check for the as86 assembler, needed for compiling the BIOS
522#
523check_as86()
524{
525 test_header as86
526 if check_avail "$AS86" AS86; then
527 as86_ver=`$AS86 -v 2>&1|grep version|sed 's+^as86 version: \(.*\)+\1+'`
528 if [ $? -ne 0 ]; then
529 log_failure "not found"
530 fail
531 else
532 log_success "found version $as86_ver"
533 cnf_append "VBOX_AS86" "`which_wrapper $AS86`"
534 fi
535 fi
536}
537
538
539#
540# Check for yasm, needed to compile assembler files
541#
542check_yasm()
543{
544 test_header yasm
545 if check_avail "$YASM" YASM; then
546 yasm_ver=`$YASM --version|grep "^yasm"|sed 's+^yasm \(.*\)+\1+'`
547 if [ $? -ne 0 ]; then
548 log_failure "not found"
549 fail
550 else
551 yasm_maj=`echo $yasm_ver|cut -d. -f1`
552 yasm_min=`echo $yasm_ver|cut -d. -f2`
553 yasm_rev=`echo $yasm_ver|cut -d. -f3`
554 yasm_ver_mul=`expr $yasm_maj \* 10000 + $yasm_min \* 100 + $yasm_rev`
555 if [ $yasm_ver_mul -lt 501 ]; then
556 log_failure "found version $yasm_ver, expected at least 0.5.1"
557 fail
558 else
559 log_success "found version $yasm_ver"
560 fi
561 fi
562 fi
563}
564
565
566#
567# Check for the iasl ACPI compiler, needed to compile vbox.dsl
568#
569check_iasl()
570{
571 test_header iasl
572 if check_avail "$IASL" IASL; then
573 iasl_ver=`$IASL|grep version|sed 's+^ASL.*version \([0-9]*\).*+\1+'`
574 if [ $? -ne 0 ]; then
575 log_failure "not found"
576 fail
577 else
578 log_success "found version $iasl_ver"
579 cnf_append "VBOX_IASLCMD" "`which_wrapper $IASL`"
580 fi
581 fi
582}
583
584
585#
586# Check for xsltproc, needed by Main
587#
588check_xsltproc()
589{
590 test_header xslt
591 if check_avail "$XSLTPROC" XSLTPROC; then
592 xsltproc_ver=`$XSLTPROC --version`
593 if [ $? -ne 0 ]; then
594 log_failure "not found"
595 fail
596 else
597 log_success "found"
598 cnf_append "VBOX_XSLTPROC" "`which_wrapper $XSLTPROC`"
599 fi
600 fi
601}
602
603
604#
605# Check for mkisofs, needed to build the CDROM image containing the additions
606#
607check_mkisofs()
608{
609 test_header mkisofs
610 if which_wrapper $GENISOIMAGE > /dev/null; then
611 mkisofs_ver=`$GENISOIMAGE --version`
612 if [ $? -ne 0 ]; then
613 log_failure "not found"
614 fail
615 else
616 log_success "found $mkisofs_ver"
617 cnf_append "VBOX_MKISOFS" "`which_wrapper $GENISOIMAGE`"
618 fi
619 elif check_avail "$MKISOFS" MKISOFS; then
620 mkisofs_ver=`$MKISOFS --version`
621 if [ $? -ne 0 ]; then
622 log_failure "not found"
623 fail
624 else
625 log_success "found $mkisofs_ver"
626 cnf_append "VBOX_MKISOFS" "`which_wrapper $MKISOFS`"
627 fi
628 fi
629}
630
631
632#
633# Check for libxml2, needed by VBoxSettings and Runtime.
634# 2.6.24 is known to NOT work, 2.6.26 is known to work (there is no 2.6.25 release)
635#
636check_libxml2()
637{
638 if [ -z "$BUILD_LIBXML2" ]; then
639 test_header libxml2
640 if which_wrapper pkg-config > /dev/null; then
641 libxml2_ver=`pkg-config libxml-2.0 --modversion 2>> $LOG`
642 if [ $? -ne 0 ]; then
643 log_failure "not found"
644 fail
645 else
646 FLGXML2=`pkg-config libxml-2.0 --cflags`
647 INCXML2=`strip_I "$FLGXML2"`
648 LIBXML2=`pkg-config libxml-2.0 --libs`
649 cat > $ODIR.tmp_src.cc << EOF
650#include <cstdio>
651#include <libxml/xmlversion.h>
652extern "C" int main(void)
653{
654 printf("found version %s", LIBXML_DOTTED_VERSION);
655#if LIBXML_VERSION >= 20626
656 printf(", OK.\n");
657 return 0;
658#else
659 printf(", expected version 2.6.26 or higher\n");
660 return 1;
661#endif
662}
663EOF
664 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
665 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
666 if test_execute; then
667 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
668 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
669 fi
670 fi
671 fi
672 elif which_wrapper xml2-config; then
673 libxml2_ver=`xml2-config --version`
674 if [ $? -ne 0 ]; then
675 log_failure "not found"
676 fail
677 else
678 log_success "found version $libxml2_ver"
679 FLGXML2=`xml2-config --cflags`
680 INCXML2=`strip_I "$FLGXML2"`
681 LIBXML2=`xml2-config --libs`
682 cat > $ODIR.tmp_src.cc << EOF
683#include <cstdio>
684#include <libxml/xmlversion.h>
685extern "C" int main(void)
686{
687 printf("found version %s", LIBXML_DOTTED_VERSION);
688#if LIBXML_VERSION >= 20626
689 printf(", OK.\n");
690 return 0;
691#else
692 printf(", expected version 2.6.26 or higher\n");
693 return 1;
694#endif
695}
696EOF
697 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
698 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
699 if test_execute; then
700 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
701 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
702 fi
703 fi
704 fi
705 else
706 log_failure "neither pkg-config nor xml2-config found"
707 fail
708 fi
709 fi
710}
711
712
713#
714# Check for libxslt, needed by VBoxSettings. For now we depend on 1.1.15,
715# as Solaris right now has no newer version and it definitely works.
716# 1.1.17 is available on Ubuntu Edgy which fulfils the minimal libxml2
717# requirement (2.6.26).
718#
719check_libxslt()
720{
721 if [ -z "$BUILD_LIBXSLT" ]; then
722 test_header libxslt
723 if which_wrapper pkg-config > /dev/null; then
724 libxslt_ver=`pkg-config libxslt --modversion 2>> $LOG`
725 if [ $? -ne 0 ]; then
726 log_failure "not found"
727 fail
728 else
729 FLGXSLT=`pkg-config libxslt --cflags`
730 INCXSLT=`strip_I "$FLGXSLT"`
731 LIBXSLT=`pkg-config libxslt --libs`
732 cat > $ODIR.tmp_src.cc << EOF
733#include <cstdio>
734#include <libxslt/xsltconfig.h>
735extern "C" int main(void)
736{
737 printf("found version %s", LIBXSLT_DOTTED_VERSION);
738#if LIBXSLT_VERSION >= 10117
739 printf(", OK.\n");
740 return 0;
741#else
742 printf(", expected version 1.1.17 or higher\n");
743 return 1;
744#endif
745}
746EOF
747 [ -n "$INCXSLT" ] && I_INCXSLT=`prefix_I "$INCXSLT"`
748 if test_compile "$LIBXSLT $LIBPTHREAD $I_INCXSLT" xslt xslt; then
749 if test_execute; then
750 cnf_append "SDK_VBOX_LIBXSLT_INCS" "$INCXSLT"
751 cnf_append "SDK_VBOX_LIBXSLT_LIBS" "`strip_l "$LIBXSLT"`"
752 fi
753 fi
754 fi
755 elif which_wrapper xslt-config; then
756 libxslt_ver=`xslt-config --version`
757 if [ $? -ne 0 ]; then
758 log_failure "not found"
759 fail
760 else
761 log_success "found version $libxslt_ver"
762 FLGXSLT=`xslt-config --cflags`
763 INCXSLT=`strip_I "$FLGXSLT"`
764 LIBXSLT=`xslt-config --libs`
765 cat > $ODIR.tmp_src.cc << EOF
766#include <cstdio>
767#include <libxslt/xsltconfig.h>
768extern "C" int main(void)
769{
770 printf("found version %s", LIBXSLT_DOTTED_VERSION);
771#if LIBXSLT_VERSION >= 10117
772 printf(", OK.\n");
773 return 0;
774#else
775 printf(", expected version 1.1.17 or higher\n");
776 return 1;
777#endif
778}
779EOF
780 [ -n "$INCXSLT" ] && I_INCXSLT=`prefix_I "$INCXSLT"`
781 if test_compile "$LIBXSLT $LIBPTHREAD $I_INCXSLT" xslt xslt; then
782 if test_execute; then
783 cnf_append "SDK_VBOX_LIBXSLT_INCS" "$INCXSLT"
784 cnf_append "SDK_VBOX_LIBXSLT_LIBS" "`strip_l "$LIBXSLT"`"
785 fi
786 fi
787 fi
788 else
789 log_failure "neither pkg-config nor xslt-config found"
790 fail
791 fi
792 fi
793}
794
795
796#
797# Check for libIDL, needed by xpcom
798#
799check_libidl()
800{
801 test_header libIDL
802
803 if which_wrapper libIDL-config-2 > /dev/null; then
804 libidl_ver=`libIDL-config-2 --version`
805 if [ $? -ne 0 ]; then
806 log_failure "not found"
807 fail
808 else
809 log_success "found version $libidl_ver"
810 cnf_append "VBOX_LIBIDL_CONFIG" \
811 "PKG_CONFIG_PATH=`libIDL-config-2 --prefix`/$LIB/pkgconfig `which_wrapper libIDL-config-2`"
812 fi
813 elif check_avail "libIDL-config" libIDL-config; then
814 libidl_ver=`libIDL-config --version`
815 if [ $? -ne 0 ]; then
816 log_failure "not found"
817 fail
818 else
819 log_success "found version $libidl_ver"
820 cnf_append "VBOX_LIBIDL_CONFIG" "`which_wrapper libIDL-config`"
821 fi
822 fi
823}
824
825
826#
827# Check for openssl, needed for RDP and S3
828#
829check_ssl()
830{
831 if [ -z "$BUILD_LIBSSL" ]; then
832 test_header ssl
833 cat > $ODIR.tmp_src.cc << EOF
834#include <cstdio>
835#include <openssl/opensslv.h>
836extern "C" int main(void)
837{
838 printf("found version %s", OPENSSL_VERSION_TEXT);
839#if OPENSSL_VERSION_NUMBER >= 0x00908000
840 printf(", OK.\n");
841 return 0;
842#else
843 printf(", expected version 0.9.8 or higher\n");
844 return 1;
845#endif
846}
847EOF
848 if test_compile "$INCCRYPTO $LIBCRYPTO" libcrypto openssl; then
849 if test_execute nofatal; then
850 cnf_append "SDK_VBOX_OPENSSL_INCS" "`strip_I "$INCCRYPTO"`"
851 cnf_append "SDK_VBOX_OPENSSL_LIBS" "`strip_l "$LIBCRYPTO"`"
852 fi
853 fi
854 fi
855}
856
857
858#
859# Check for pthread, needed by VBoxSVC, frontends, ...
860#
861check_pthread()
862{
863 test_header pthread
864 cat > $ODIR.tmp_src.cc << EOF
865#include <cstdio>
866#include <pthread.h>
867extern "C" int main(void)
868{
869 pthread_mutex_t mutex;
870 if (pthread_mutex_init(&mutex, NULL)) {
871 printf("pthread_mutex_init() failed\n");
872 return 1;
873 }
874 if (pthread_mutex_lock(&mutex)) {
875 printf("pthread_mutex_lock() failed\n");
876 return 1;
877 }
878 if (pthread_mutex_unlock(&mutex)) {
879 printf("pthread_mutex_unlock() failed\n");
880 return 1;
881 }
882 printf("found, OK.\n");
883}
884EOF
885 if test_compile $LIBPTHREAD pthread pthread; then
886 if test_execute; then
887 cnf_append "LIB_PTHREAD" "`strip_l "$LIBPTHREAD"`"
888 fi
889 fi
890}
891
892
893#
894# Check for zlib, needed by VBoxSVC, Runtime, ...
895#
896check_z()
897{
898 test_header zlib
899 cat > $ODIR.tmp_src.cc << EOF
900#include <cstdio>
901#include <zlib.h>
902extern "C" int main(void)
903{
904 printf("found version %s", ZLIB_VERSION);
905#if ZLIB_VERNUM >= 0x1210
906 printf(", OK.\n");
907 return 0;
908#else
909 printf(", expected version 1.2.1 or higher\n");
910 return 1;
911#endif
912}
913EOF
914 [ -n "$INCZ" ] && I_INCZ=`prefix_I "$INCZ"`
915 if test_compile "$LIBZ $I_INCZ" zlib zlib; then
916 if test_execute; then
917 echo "if1of (\$(KBUILD_TARGET),darwin freebsd linux solaris)" >> $CNF
918 cnf_append " SDK_VBOX_ZLIB_LIBS" "`strip_l "$LIBZ"`"
919 cnf_append " SDK_VBOX_ZLIB_INCS" "$INCZ"
920 echo "endif" >> $CNF
921 fi
922 fi
923}
924
925
926#
927# Check for libpng, needed by kchmviewer
928#
929check_png()
930{
931 test_header libpng
932 cat > $ODIR.tmp_src.cc << EOF
933#include <cstdio>
934#include <png.h>
935extern "C" int main(void)
936{
937 printf("found version %s", PNG_LIBPNG_VER_STRING);
938#if PNG_LIBPNG_VER >= 10205
939 printf(", OK.\n");
940 return 0;
941#else
942 printf(", expected version 1.2.5 or higher\n");
943 return 1;
944#endif
945}
946EOF
947 [ -n "$INCPNG" ] && I_INCPNG=`prefix_I "$INCPNG"`
948 if test_compile "$LIBPNG $I_INCPNG" libpng libpng; then
949 if test_execute; then
950 cnf_append "SDK_VBOX_LIBPNG_LIBS" "`strip_l "$LIBPNG"`"
951 cnf_append "SDK_VBOX_LIBPNG_INCS" "$INCPNG"
952 fi
953 fi
954}
955
956#
957# Check for libcurl, needed by S3
958#
959check_curl()
960{
961 if [ -z "$BUILD_LIBCURL" ]; then
962 test_header libcurl
963 cat > $ODIR.tmp_src.cc << EOF
964#include <cstdio>
965#include <curl/curl.h>
966extern "C" int main(void)
967{
968 printf("found version %s", LIBCURL_VERSION);
969#if 10000*LIBCURL_VERSION_MAJOR + 100*LIBCURL_VERSION_MINOR + LIBCURL_VERSION_PATCH >= 71601
970 printf(", OK.\n");
971 return 0;
972#else
973 printf(", expected version 7.16.1 or higher\n");
974 return 1;
975#endif
976}
977EOF
978 [ -n "$INCCURL" ] && I_INCCURL=`prefix_I "$INCCURL"`
979 if test_compile "$LIBCURL $I_INCCURL" libcurl libcurl; then
980 if test_execute; then
981 cnf_append "SDK_VBOX_LIBCURL_LIBS" "`strip_l "$LIBCURL"`"
982 cnf_append "SDK_VBOX_LIBCURL_INCS" "$INCCURL"
983 fi
984 fi
985 fi
986}
987
988
989#
990# Check for pam, needed by VRDPAuth
991# Version 79 was introduced in 9/2005, do we support older versions?
992# Debian/sarge uses 76
993# OpenSUSE comes with 0.99.xxx where they changed the versioning scheme.
994#
995check_pam()
996{
997 test_header pam
998 cat > $ODIR.tmp_src.cc << EOF
999#include <cstdio>
1000#include <security/pam_appl.h>
1001extern "C" int main(void)
1002{
1003 printf("found version %d", __LIBPAM_VERSION);
1004 if (__LIBPAM_VERSION >= 76)
1005 {
1006 printf(", OK.\n");
1007 return 0;
1008 }
1009 else
1010 {
1011 printf(", expected version 76 or higher\n");
1012 return 1;
1013 }
1014}
1015EOF
1016 if test_compile "-lpam" pam pam nofatal; then
1017 if test_execute nofatal; then
1018 return 0;
1019 fi
1020 fi
1021 echo "not found."
1022 test_header linux_pam
1023 cat > $ODIR.tmp_src.cc << EOF
1024#include <cstdio>
1025#include <security/pam_appl.h>
1026extern "C" int main(void)
1027{
1028 printf("found version %d.%d", __LINUX_PAM__, __LINUX_PAM_MINOR__);
1029 if (__LINUX_PAM__ >= 1)
1030 {
1031 printf(", OK.\n");
1032 return 0;
1033 }
1034 else
1035 {
1036 printf(", expected version 1.0 or higher\n");
1037 return 1;
1038 }
1039}
1040EOF
1041 if test_compile "-lpam" pam pam; then
1042 test_execute
1043 fi
1044}
1045
1046
1047#
1048# Check for the SDL library, needed by VBoxSDL and VirtualBox
1049# We depend at least on version 1.2.7
1050#
1051check_sdl()
1052{
1053 test_header SDL
1054 if [ "$OS" = "darwin" ]; then
1055 if [ -f "/System/Library/Frameworks/SDL.framework/SDL" ]; then
1056 PATH_SDK_LIBSDL="/System/Library/Frameworks/SDL.framework"
1057 elif [ -f "/Library/Frameworks/SDL.framework/SDL" ]; then
1058 PATH_SDK_LIBSDL="/Library/Frameworks/SDL.framework"
1059 fi
1060 if [ -n "$PATH_SDK_LIBSDL" ]; then
1061 foundsdl=1
1062 INCSDL="$PATH_SDK_LIBSDL/Headers"
1063 FLDSDL="-framework SDL"
1064 else
1065 log_failure "SDL framework not found"
1066 fail
1067 fi
1068 else
1069 if which_wrapper sdl-config > /dev/null; then
1070 FLGSDL=`sdl-config --cflags`
1071 INCSDL=`strip_I "$FLGSDL"`
1072 LIBSDL=`sdl-config --libs`
1073 LIBSDLMAIN="-lSDLmain"
1074 FLDSDL=
1075 foundsdl=1
1076 fi
1077 fi
1078 [ "$OS" = "linux" -o "$OS" = "darwin" -o "$OS" = "solaris" ] && LIBSDLMAIN=""
1079 if [ -n "$foundsdl" ]; then
1080 cat > $ODIR.tmp_src.cc << EOF
1081#include <cstdio>
1082#include <SDL.h>
1083#include <SDL_main.h>
1084#undef main
1085extern "C" int main(int argc, char** argv)
1086{
1087 printf("found version %d.%d.%d",
1088 SDL_MAJOR_VERSION, SDL_MINOR_VERSION, SDL_PATCHLEVEL);
1089#if SDL_VERSION_ATLEAST(1,2,7)
1090 printf(", OK.\n");
1091 return 0;
1092#else
1093 printf(", expected version 1.2.7 or higher\n");
1094 return 1;
1095#endif
1096}
1097EOF
1098 [ -n "$INCSDL" ] && I_INCSDL=`prefix_I "$INCSDL"`
1099 if test_compile "$LIBSDL $LIBSDLMAIN $I_INCSDL $FLDSDL" SDL SDL; then
1100 if test_execute; then
1101 cnf_append "LIB_SDK_LIBSDL_SDL" "`strip_l "$LIBSDL"`"
1102 cnf_append "SDK_LIBSDL_LIBPATH" "`strip_L "$LIBSDL"`"
1103 cnf_append "LIB_SDK_LIBSDL_SDLMAIN" "`strip_l "$LIBSDLMAIN"`"
1104 [ -n "$INCSDL" ] && cnf_append "SDK_LIBSDL_INCS" "$INCSDL"
1105 [ -n "$FLDSDL" ] && cnf_append "SDK_LIBSDL_LDFLAGS" "$FLDSDL"
1106 fi
1107 fi
1108 else
1109 log_failure "not found"
1110 fail
1111 fi
1112}
1113
1114
1115#
1116# Check for the SDL_ttf library, needed by VBoxSDL (secure label)
1117#
1118check_sdl_ttf()
1119{
1120 test_header SDL_ttf
1121 cat > $ODIR.tmp_src.cc << EOF
1122#include <cstdio>
1123#include <SDL_ttf.h>
1124#ifndef SDL_TTF_MAJOR_VERSION
1125#define SDL_TTF_MAJOR_VERSION TTF_MAJOR_VERSION
1126#define SDL_TTF_MINOR_VERSION TTF_MINOR_VERSION
1127#define SDL_TTF_PATCHLEVEL TTF_PATCHLEVEL
1128#endif
1129extern "C" int main(void)
1130{
1131 printf("found version %d.%d.%d",
1132 SDL_TTF_MAJOR_VERSION, SDL_TTF_MINOR_VERSION, SDL_TTF_PATCHLEVEL);
1133#if 10000*SDL_TTF_MAJOR_VERSION + 100*SDL_TTF_MINOR_VERSION + SDL_TTF_PATCHLEVEL >= 20006
1134 printf(", OK.\n");
1135 return 0;
1136#else
1137 printf(", expected version 2.0.6 or higher\n");
1138 return 1;
1139#endif
1140}
1141EOF
1142 if test_compile "-lSDL_ttf $I_INCSDL" SDL_ttf SDL_ttf nofatal; then
1143 if ! test_execute nofatal; then
1144 cnf_append "VBOX_WITH_SECURELABEL" ""
1145 fi
1146 else
1147 echo "not found -- disabling VBoxSDL secure label."
1148 cnf_append "VBOX_WITH_SECURELABEL" ""
1149 fi
1150}
1151
1152
1153#
1154# Check for libasound, needed by the ALSA audio backend
1155#
1156check_alsa()
1157{
1158 test_header ALSA
1159 cat > $ODIR.tmp_src.cc << EOF
1160#include <cstdio>
1161#include <alsa/asoundlib.h>
1162extern "C" int main(void)
1163{
1164 printf("found version %d.%d.%d",
1165 SND_LIB_MAJOR, SND_LIB_MINOR, SND_LIB_SUBMINOR);
1166#if 10000*SND_LIB_MAJOR + 100*SND_LIB_MINOR + SND_LIB_SUBMINOR >= 10006
1167 printf(", OK.\n");
1168 return 0;
1169#else
1170 printf(", expected version 1.0.6 or higher\n");
1171 return 1;
1172#endif
1173}
1174EOF
1175 if test_compile "-lasound" asound asound; then
1176 test_execute
1177 fi
1178}
1179
1180
1181#
1182# Check for PulseAudio
1183#
1184check_pulse()
1185{
1186 test_header "PulseAudio"
1187 cat > $ODIR.tmp_src.cc << EOF
1188#include <cstdio>
1189#include <pulse/version.h>
1190extern "C" int main(void)
1191{
1192 printf("found version %s API version %d", pa_get_headers_version(), PA_API_VERSION);
1193#if PA_API_VERSION >= 9
1194 printf(", OK.\n");
1195 return 0;
1196#else
1197 printf(", expected version 0.9.0 (API version 9) or higher\n");
1198 return 1;
1199#endif
1200}
1201EOF
1202 if test_compile "$INCPULSE $LIBPULSE -lpulse" pulse pulse; then
1203 test_execute
1204 fi
1205}
1206
1207
1208#
1209# Check for the X libraries (Xext, X11)
1210#
1211check_x()
1212{
1213 test_header "X libraries"
1214 cat > $ODIR.tmp_src.cc << EOF
1215#include <cstdio>
1216#include <X11/Xlib.h>
1217extern "C" int main(void)
1218{
1219 Display *dpy;
1220 int scrn_num;
1221 Screen *scrn;
1222 Window win;
1223
1224 dpy = XOpenDisplay(NULL);
1225 scrn_num = DefaultScreen(dpy);
1226 scrn = ScreenOfDisplay(dpy, scrn_num);
1227 win = XCreateWindow(dpy, RootWindowOfScreen(scrn), 0, 0, 100, 100,
1228 0, 16, InputOutput, CopyFromParent, 0, NULL);
1229 XDestroyWindow(dpy, win);
1230 XCloseDisplay(dpy);
1231}
1232EOF
1233 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1234 if test_compile "$LIBX11 $I_INCX11" Xlibs Xlibs; then
1235 log_success "found"
1236 fi
1237}
1238
1239
1240#
1241# Check for the Xcursor library, needed by VBoxSDL and VBoxBFE
1242#
1243check_xcursor()
1244{
1245 test_header Xcursor
1246 cat > $ODIR.tmp_src.cc << EOF
1247#include <cstdio>
1248#include <X11/Xlib.h>
1249#include <X11/Xcursor/Xcursor.h>
1250extern "C" int main(void)
1251{
1252 XcursorImage *cursor = XcursorImageCreate (10, 10);
1253 XcursorImageDestroy(cursor);
1254 return 0;
1255}
1256EOF
1257 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1258 if test_compile "$LIBX11 $LIBXCURSOR $I_INCX11" Xcursor Xcursor; then
1259 log_success "found"
1260 cnf_append "VBOX_XCURSOR_LIBS" "`strip_l "$LIBXCURSOR"`"
1261 fi
1262}
1263
1264
1265#
1266# Check for the Xinerama library, needed by the Qt GUI
1267#
1268check_xinerama()
1269{
1270 test_header Xinerama
1271 cat > $ODIR.tmp_src.cc << EOF
1272#include <X11/Xlib.h>
1273#include <X11/extensions/Xinerama.h>
1274extern "C" int main(void)
1275{
1276 Display *dpy;
1277 Bool flag;
1278 dpy = XOpenDisplay(NULL);
1279 if (dpy)
1280 {
1281 flag = XineramaIsActive(dpy);
1282 XCloseDisplay(dpy);
1283 }
1284}
1285EOF
1286 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1287 if test_compile "$LIBX11 $LIBXINERAMA $I_INCX11" Xinerama Xinerama; then
1288 log_success "found"
1289 fi
1290}
1291
1292
1293#
1294# Check for the Xinerama library, needed by the Qt GUI
1295#
1296check_xrandr()
1297{
1298 test_header Xrandr
1299 cat > $ODIR.tmp_src.cc << EOF
1300#include <X11/Xlib.h>
1301#include <X11/extensions/Xrandr.h>
1302extern "C" int main(void)
1303{
1304 Display *dpy;
1305 Bool flag;
1306 int major, minor;
1307 dpy = XOpenDisplay(NULL);
1308 if (dpy)
1309 {
1310 flag = XRRQueryVersion(dpy, &major, &minor);
1311 XCloseDisplay(dpy);
1312 }
1313}
1314EOF
1315 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1316 if test_compile "$LIBX11 $LIBXRANDR $I_INCX11" Xrandr Xrandr; then
1317 log_success "found"
1318 fi
1319}
1320
1321
1322#
1323# Check for OpenGL
1324#
1325check_opengl()
1326{
1327 # On darwin this is a on/off decision only
1328 if [ "$OS" = "darwin" ]; then
1329 test_header "OpenGL support"
1330 echo "enabled"
1331 cnf_append "VBOX_WITH_CROGL" "1"
1332 else
1333 check_xmu
1334 check_mesa
1335 fi
1336}
1337
1338
1339#
1340# Check for the Xmu library, needed by OpenGL
1341#
1342check_xmu()
1343{
1344 test_header Xmu
1345 cat > $ODIR.tmp_src.cc << EOF
1346#include <cstdio>
1347#include <X11/Xatom.h>
1348#include <X11/Xlib.h>
1349#include <X11/Xutil.h>
1350#include <X11/Xmu/StdCmap.h>
1351extern "C" int main(void)
1352{
1353 Display *dpy;
1354 int scrn_num;
1355 Screen *scrn;
1356
1357 dpy = XOpenDisplay(NULL);
1358 if (dpy)
1359 {
1360 scrn_num = DefaultScreen(dpy);
1361 scrn = ScreenOfDisplay(dpy, scrn_num);
1362 Status status = XmuLookupStandardColormap(dpy, RootWindowOfScreen(scrn), 0,
1363 24, XA_RGB_DEFAULT_MAP, False, True);
1364 printf("Status = %x\n", status);
1365 XCloseDisplay(dpy);
1366 }
1367 return 0;
1368}
1369EOF
1370 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1371 if test_compile "$LIBX11 $LIBXMU $I_INCX11" Xmu Xmu; then
1372 log_success "found"
1373 cnf_append "VBOX_XMU_LIBS" "`strip_l "$LIBXMU"`"
1374 fi
1375}
1376
1377#
1378# Check for Mesa, needed by OpenGL
1379#
1380check_mesa()
1381{
1382 test_header "Mesa / GLU"
1383 cat > $ODIR.tmp_src.cc << EOF
1384#include <cstdio>
1385#include <X11/Xlib.h>
1386#include <GL/glx.h>
1387#include <GL/glu.h>
1388extern "C" int main(void)
1389{
1390 Display *dpy;
1391 int major, minor;
1392
1393 dpy = XOpenDisplay(NULL);
1394 if (dpy)
1395 {
1396 Bool glx_version = glXQueryVersion(dpy, &major, &minor);
1397 XCloseDisplay(dpy);
1398 if (glx_version)
1399 {
1400 printf("found version %u.%u, OK.\n", major, minor);
1401 return 0;
1402 }
1403 }
1404 printf("found (inactive), OK.\n");
1405 return 0;
1406}
1407EOF
1408 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1409 if test_compile "$LIBX11 $MESA $I_INCX11" Mesa Mesa; then
1410 [ $PASSIVE_MESA -eq 1 ] && unset DISPLAY
1411 test_execute
1412 fi
1413}
1414
1415
1416#
1417# Check for the Qt4 library, needed by the VirtualBox frontend
1418#
1419# Currently not fatal.
1420#
1421check_qt4()
1422{
1423 foundqt4=
1424 test_header Qt4
1425 if [ "$OS" = "darwin" ]; then
1426 # First check if there is the internal version of Qt. If yes nothing else
1427 # has to be done.
1428 QT_INTERNAL=`/bin/ls -rd1 $PWD/tools/$BUILD_TARGET.$BUILD_PLATFORM_ARCH/qt/* 2> /dev/null`
1429 for t in $QT_INTERNAL; do
1430 if [ -f "$t/Frameworks/QtCoreVBox.framework/QtCoreVBox" ]; then
1431 cnf_append "VBOX_WITH_QT4_SUN" "1"
1432 log_success "use internal version"
1433 return
1434 fi
1435 done
1436 # Now try the user provided directory and some of the standard directories.
1437 QT_TRIES="$QT4DIR /System/Library /Library"
1438 for t in $QT_TRIES; do
1439 if [ -f "$t/Frameworks/QtCore.framework/QtCore" ]; then
1440 PATH_SDK_QT4="$t"
1441 break
1442 fi
1443 done
1444 # Add the necessary params for building the test application
1445 if [ -n "$PATH_SDK_QT4" ]; then
1446 foundqt4=1
1447 INCQT4=-I$PATH_SDK_QT4/Frameworks/QtCore.framework/Headers
1448 LIBQT4=-F$PATH_SDK_QT4/Frameworks
1449 FLGQT4="-framework QtCore"
1450 else
1451 log_failure "Qt4 framework not found (can be disabled using --disable-qt4)"
1452 fail
1453 fi
1454 else
1455 if [ $QT4DIR_PKGCONFIG -eq 1 ]; then
1456 # default is to use pkg-config
1457 if which_wrapper pkg-config > /dev/null; then
1458 # this braindead path is necessary for mdv2008.1
1459 qt4_ver=`\
1460 PKG_CONFIG_PATH=/usr/lib/qt4/lib/pkgconfig \
1461 pkg-config QtCore --modversion 2>> $LOG`
1462 if [ $? -ne 0 ]; then
1463 log_failure "not found"
1464 fail
1465 else
1466 FLGQT4=`\
1467 PKG_CONFIG_PATH=/usr/lib/qt4/lib/pkgconfig \
1468 pkg-config QtCore --cflags`
1469 INCQT4=`strip_I "$FLGQT4"`
1470 LIBQT4=`\
1471 PKG_CONFIG_PATH=/usr/lib/qt4/lib/pkgconfig \
1472 PKG_CONFIG_ALLOW_SYSTEM_LIBS=1 \
1473 pkg-config QtCore --libs`
1474 foundqt4=1
1475 fi
1476 else
1477 log_failure "pkg-config not found"
1478 fail
1479 fi
1480 else
1481 # do it the old way (e.g. user has specified QT4DIR)
1482 cat > $ODIR.tmp_src.cc << EOF
1483#include <cstdio>
1484#include <QtGlobal>
1485extern "C" int main(void)
1486{
1487 printf("found version %s", QT_VERSION_STR);
1488#if QT_VERSION >= 0x040400
1489 printf(", OK.\n");
1490 return 0;
1491#else
1492 printf(", expected version 4.4.0 or higher\n");
1493 return 1;
1494#endif
1495}
1496EOF
1497 for q in $QT4DIR; do
1498 INCQT4="$q/include $q/include/QtCore"
1499 FLGQT4="-DQT_SHARED"
1500 I_INCQT4=`prefix_I "$INCQT4"`
1501 LIBQT4="-L$q/lib -lQtCoreVBox"
1502 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1503 foundqt4=2
1504 break;
1505 fi
1506 LIBQT4="-L$q/lib -lQtCore"
1507 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1508 foundqt4=1
1509 break;
1510 fi
1511 done
1512 fi
1513 fi
1514 if [ -n "$foundqt4" ]; then
1515 cat > $ODIR.tmp_src.cc << EOF
1516#include <cstdio>
1517#include <QtGlobal>
1518extern "C" int main(void)
1519{
1520 printf("found version %s", QT_VERSION_STR);
1521#if QT_VERSION >= 0x040400
1522 printf(", OK.\n");
1523 return 0;
1524#else
1525 printf(", expected version 4.4.0 or higher\n");
1526 return 1;
1527#endif
1528}
1529EOF
1530 [ -n "$INCQT4" ] && I_INCQT4=`prefix_I "$INCQT4"`
1531 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1532 if test_execute_path "`strip_L "$LIBQT4"`"; then
1533 if [ "$OS" = "darwin" ]; then
1534 # Successful build & run the test application so add the necessary
1535 # params to AutoConfig.kmk
1536 cnf_append "PATH_SDK_QT4_INC" "$PATH_SDK_QT4/Frameworks"
1537 cnf_append "PATH_SDK_QT4_LIB" "$PATH_SDK_QT4/Frameworks"
1538 cnf_append "PATH_SDK_QT4" "$PATH_SDK_QT4/Frameworks"
1539 # Check for the moc tool in the Qt directory found & some standard
1540 # directories.
1541 for q in $PATH_SDK_QT4 /usr /Developer/Tools/Qt; do
1542 if which_wrapper "$q/bin/moc" > /dev/null; then
1543 cnf_append "PATH_TOOL_QT4" "$q"
1544 cnf_append "PATH_TOOL_QT4_BIN" "$q/bin"
1545 fi
1546 done
1547 else
1548 # strip .../QtCore as we add components ourself
1549 INCQT4=`echo "$INCQT4"|$KBUILD_SED 's|\([^ ]*\)/QtCore|\1|g; s| $||g'`
1550 # store only the first path, remove all other pathes
1551 # most likely pkg-config gave us -I/usr/include/qt4 -I/usr/include/qt4/QtCore
1552 INCQT4=`echo "$INCQT4"|$KBUILD_SED 's|\([^ ]*\) .*|\1|'`
1553 cnf_append "VBOX_PATH_QT4_LIB" "`strip_L "$LIBQT4"`"
1554 cnf_append "SDK_QT4_LIBPATH" "`strip_L "$LIBQT4"`"
1555 cnf_append "PATH_SDK_QT4_INC" "$INCQT4"
1556 # this is not quite right since the qt libpath does not have to be first...
1557 cnf_append "PATH_SDK_QT4_LIB" '$'"(firstword `strip_L "$LIBQT4"`)"
1558 if [ "$foundqt4" = "2" ]; then
1559 cnf_append "VBOX_WITH_QT4_SUN" "1"
1560 fi
1561 test_header "Qt4 devtools"
1562 for q in $QT4DIR; do
1563 # first try it with a suffix, some platforms use that
1564 if which_wrapper "$q/bin/moc-qt4" > /dev/null; then
1565 moc_ver=`$q/bin/moc-qt4 -v 2>&1|sed 's+^.*(Qt \(.*\))+\1+'`
1566 if [ $? -ne 0 ]; then
1567 log_failure "not found"
1568 fail
1569 else
1570 log_success "found version $moc_ver"
1571 cnf_append "VBOX_PATH_QT4" "$q"
1572 cnf_append "PATH_SDK_QT4" "$q"
1573 cnf_append "PATH_TOOL_QT4" "$q"
1574 cnf_append "PATH_TOOL_QT4_BIN" "$q/bin"
1575 cnf_append "TOOL_QT4_BIN_SUFF" "-qt4"
1576 return
1577 fi
1578 elif which_wrapper "$q/bin/moc" > /dev/null; then
1579 moc_ver=`$q/bin/moc -v 2>&1|sed 's+^.*(Qt \(.*\))+\1+'`
1580 if [ $? -ne 0 ]; then
1581 log_failure "not found"
1582 fail
1583 else
1584 log_success "found version $moc_ver"
1585 cnf_append "VBOX_PATH_QT4" "$q"
1586 cnf_append "PATH_SDK_QT4" "$q"
1587 cnf_append "PATH_TOOL_QT4" "$q"
1588 cnf_append "PATH_TOOL_QT4_BIN" "$q/bin"
1589 return
1590 fi
1591 fi
1592 done
1593 fi
1594 fi
1595 else
1596 log_failure "not found"
1597 fail
1598 fi
1599 else
1600 log_failure "not found"
1601 fail
1602 fi
1603}
1604
1605
1606#
1607# Check whether static libstdc++ is installed. This library is required
1608# for the Linux guest additions.
1609#
1610check_staticlibstdcxx()
1611{
1612 test_header "static stc++ library"
1613 libstdcxx=`$CXX -print-file-name=libstdc++.a`
1614 cat > $ODIR.tmp_src.cc << EOF
1615#include <string>
1616
1617extern "C" int main(void)
1618{
1619 std::string s = "test";
1620 return 0;
1621}
1622EOF
1623 if test_compile "$libstdcxx" libstdc++ libstdc++; then
1624 log_success "found"
1625 fi
1626}
1627
1628
1629#
1630# Check for Linux sources
1631#
1632check_linux()
1633{
1634 test_header "Linux kernel sources"
1635 cat > $ODIR.tmp_src.c << EOF
1636#include <linux/version.h>
1637int printf(const char *format, ...);
1638int main(void)
1639{
1640 printf("found version %d.%d.%d", LINUX_VERSION_CODE / 65536,
1641 (LINUX_VERSION_CODE % 65536) / 256,
1642 LINUX_VERSION_CODE % 256);
1643#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,0)
1644 printf(", OK.\n");
1645 return 0;
1646#else
1647 printf(", expected version 2.4.0 or higher\n");
1648 return 1;
1649#endif
1650}
1651EOF
1652 echo "compiling the following source file:" >> $LOG
1653 cat $ODIR.tmp_src.c >> $LOG
1654 echo "using the following command line:" >> $LOG
1655 echo "$CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include" >> $LOG
1656 $CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include >> $LOG 2>&1
1657 if [ $? -ne 0 ]; then
1658 echo
1659 echo " Linux kernel headers not found at $LINUX"
1660 echo " Check the file $LOG for detailed error information."
1661 fail
1662 else
1663 if test_execute; then
1664 cnf_append "VBOX_LINUX_SRC" "`cd $LINUX ; pwd`"
1665 fi
1666 fi
1667}
1668
1669
1670#
1671# Check for kchmviewer, needed to display the online help
1672# (unused as we ship kchmviewer)
1673#
1674check_kchmviewer()
1675{
1676 test_header kchmviewer
1677 if check_avail "$KCHMVIEWER" KCHMVIEWER; then
1678 kchmviewer_ver=`$KCHMVIEWER --version|grep "^KchmViewer:"|sed 's+^KchmViewer: \(.*\)+\1+'`
1679 if [ $? -ne 0 ]; then
1680 log_failure "not found"
1681 fail
1682 else
1683 log_success "found version $kchmviewer_ver"
1684 fi
1685 fi
1686}
1687
1688
1689#
1690# Check for the kBuild tools, we don't support GNU make
1691#
1692check_kbuild()
1693{
1694 test_header kBuild
1695 if which_wrapper "$KBUILDDIR/bin/$OS.$BUILD_MACHINE/kmk" > /dev/null; then
1696 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.$BUILD_MACHINE"
1697 echo "PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1698 echo "export PATH_KBUILD" >> $ENV
1699 echo "PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1700 echo "export PATH_DEVTOOLS" >> $ENV
1701 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"" >> $ENV
1702 echo "export PATH_KBUILD_BIN" >> $ENV
1703 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1704 if [ "$OS" = "solaris" ]; then
1705 # Because of sh being non-default shell in Solaris we need to export PATH again when
1706 # sourcing env.sh. Simply exporting from ./configure does not export PATH correctly.
1707 echo "PATH=\"$ORGPATH\"" >> $ENV
1708 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1709 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1710 else
1711 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1712 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1713 fi
1714 echo "export PATH" >> $ENV
1715 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1716 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
1717 elif [ "$OS.$BUILD_MACHINE" = "darwin.amd64" ]; then
1718 # Currently there are no amd64 kBuild bins. So use the x86 variant in any case.
1719 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.x86"
1720 echo "PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1721 echo "export PATH_KBUILD" >> $ENV
1722 echo "PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1723 echo "export PATH_DEVTOOLS" >> $ENV
1724 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.x86\"" >> $ENV
1725 echo "PATH_KBUILD_BIN=\"\$path_kbuild_bin\"" >> $ENV
1726 echo "export PATH_KBUILD_BIN" >> $ENV
1727 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1728 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1729 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1730 echo "export PATH" >> $ENV
1731 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1732 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
1733 elif check_avail "kmk" KBUILDDIR really; then
1734 # check for installed kBuild
1735 KBUILD_SED="`which_wrapper kmk_sed`"
1736 else
1737 fail
1738 fi
1739 log_success "found"
1740}
1741
1742
1743#
1744# Check for compiler.h
1745# Some Linux distributions include "compiler.h" in their libc linux
1746# headers package, some don't. Most don't need it, building might (!)
1747# not succeed on openSUSE without it.
1748#
1749# See http://www.mail-archive.com/qemu-devel%40nongnu.org/msg07980.html
1750#
1751check_compiler_h()
1752{
1753 test_header compiler.h
1754 if ! test -f "/usr/include/linux/compiler.h"; then
1755 log_success "compiler.h not found"
1756 else
1757 cnf_append "VBOX_WITH_LINUX_COMPILER_H" "1"
1758 log_success "compiler.h found"
1759 fi
1760}
1761
1762#
1763# Check for libcap.
1764# Required to pass CAP_NET_RAW to our binaries to allow to open SOCK_RAW
1765# sockets for doing ICMP requests.
1766#
1767check_libcap()
1768{
1769 test_header "libcap library"
1770 cat > $ODIR.tmp_src.cc << EOF
1771#include <cstdio>
1772#include <sys/types.h>
1773#include <sys/capability.h>
1774
1775extern "C" int main(void)
1776{
1777 char buf[1024];
1778 cap_t caps = cap_get_proc();
1779 snprintf(buf, sizeof(buf), "Current caps are '%s'\n", cap_to_text(caps, NULL));
1780 return 0;
1781}
1782EOF
1783 if test_compile $LIBCAP libcap libcap; then
1784 if test_execute; then
1785 log_success "found"
1786 fi
1787 fi
1788}
1789
1790#
1791# Check if we are able to build 32-bit applications (needed for the guest additions)
1792#
1793check_32bit()
1794{
1795 test_header "32-bit support"
1796 cat > $ODIR.tmp_src.c << EOF
1797#include <stdint.h>
1798int main(void)
1799{
1800 return 0;
1801}
1802EOF
1803 echo "compiling the following source file:" >> $LOG
1804 cat $ODIR.tmp_src.c >> $LOG
1805 echo "using the following command line:" >> $LOG
1806 echo "$CC -m32 -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c" >> $LOG
1807 $CC -m32 -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c >> $LOG 2>&1
1808 if [ $? -ne 0 ]; then
1809 echo
1810 echo " Cannot compile 32-bit applications (missing headers and/or libraries)!"
1811 echo " Check the file $LOG for detailed error information."
1812 fail
1813 else
1814 echo "executing the binary" >> $LOG
1815 $ODIR.tmp_out 2> $ODIR.test_execute.log
1816 rc=$?
1817 cat $ODIR.test_execute.log >> $LOG
1818 if [ $rc -ne 0 ]; then
1819 echo
1820 echo " Cannot execute 32-bit applications! Either enable 32-bit support in the"
1821 echo " kernel configuration or use --disable-vmmraw to disable 32-bit guests."
1822 fail
1823 return 1
1824 fi
1825 fi
1826 log_success ""
1827}
1828
1829
1830#
1831# Check for Python
1832#
1833check_python()
1834{
1835 test_header "Python support"
1836
1837 # On darwin this is a on/off decision only
1838 if [ "$OS" = "darwin" ]; then
1839 echo "enabled"
1840 cnf_append "VBOX_WITH_PYTHON" "1"
1841 return
1842 fi
1843
1844 cat > $ODIR.tmp_src.cc << EOF
1845#include <cstdio>
1846#include <Python.h>
1847extern "C" int main(void)
1848{
1849 Py_Initialize();
1850 printf("found version %s", PY_VERSION);
1851#if PY_VERSION_HEX >= 0x02030000
1852 printf(", OK.\n");
1853 return 0;
1854#else
1855 printf(", expected version 2.3 or higher\n");
1856 return 1;
1857#endif
1858}
1859EOF
1860 found=
1861# For Solaris we use libpython2.4 for compatibility with Solaris 10 and passing IPS pkg audit
1862 if [ "$OS" != "solaris" ]; then
1863 SUPPYTHONLIBS="python2.7 python2.6 python2.5 python2.4 python2.3"
1864 else
1865 SUPPYTHONLIBS="python2.4"
1866 fi
1867 for p in $PYTHONDIR; do
1868 for d in $SUPPYTHONLIBS; do
1869 for b in lib64 lib/64 lib; do
1870 echo "compiling the following source file:" >> $LOG
1871 cat $ODIR.tmp_src.cc >> $LOG
1872 echo "using the following command line:" >> $LOG
1873 echo "$CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc -I$p/include/$d $p/$b/lib$d.so" >> $LOG
1874 $CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc -I$p/include/$d $p/$b/lib$d.so >> $LOG 2>&1
1875 if [ $? -eq 0 ]; then
1876 found=1
1877 break
1878 fi
1879 done
1880 if [ -n "$found" ]; then break; fi
1881 done
1882 if [ -n "$found" ]; then break; fi
1883 done
1884 if [ -n "$found" ]; then
1885 if test_execute; then
1886 cnf_append "VBOX_WITH_PYTHON" "1"
1887 cnf_append "VBOX_PATH_PYTHON_INC" "$p/include/$d"
1888 cnf_append "VBOX_LIB_PYTHON" "$p/$b/lib$d.so"
1889 else
1890 log_failure "not found"
1891 fail
1892 fi
1893 else
1894 log_failure "not found"
1895 fail
1896 fi
1897}
1898
1899
1900#
1901# Check for Java
1902#
1903check_java()
1904{
1905 test_header "Java support"
1906 log_success
1907}
1908
1909
1910#
1911# Setup wine
1912#
1913setup_wine()
1914{
1915 test_header "Wine support"
1916 if ! which_wrapper wine > /dev/null; then
1917 echo " wine binary not found"
1918 fail
1919 fi
1920 if ! which_wrapper wineprefixcreate > /dev/null; then
1921 echo " wineprefixcreate not found"
1922 fail
1923 fi
1924 export WINEPREFIX="${ODIR}wine.$BUILD_MACHINE"
1925 echo "WINEPREFIX=\"${ODIR}wine.$BUILD_MACHINE\"" >> $ENV
1926 echo "export WINEPREFIX" >> $ENV
1927 rm -rf $WINEPREFIX
1928 mkdir -p $WINEPREFIX
1929 touch $WINEPREFIX/.no_prelaunch_window_flag
1930 if ! wineprefixcreate -q > /dev/null 2>&1; then
1931 echo " wineprefixcreate failed"
1932 fail
1933 fi
1934 tmp=.tmp.wine.reg
1935 rm -f $tmp
1936 echo 'REGEDIT4' > $tmp
1937 echo '' >> $tmp
1938 echo '[HKEY_LOCAL_MACHINE\System\CurrentControlSet\Control\Session Manager\Environment]' >> $tmp
1939 echo "\"PATH\"=\"c:\\\\\\\\windows\\\\\\\\system32;c:\\\\\\\\windows;z:$DEVDIR/win.x86/vcc/v8/bin/Microsoft.VC80.CRT;z:$DEVDIR/win.x86/HTML_Help_Workshop/v1.3\"" >> $tmp
1940 echo '' >> $tmp
1941 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhc.exe\DllOverrides]' >> $tmp
1942 echo '"itss"="native"' >> $tmp
1943 echo '' >> $tmp
1944 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhw.exe\DllOverrides]' >> $tmp
1945 echo '"itss"="native"' >> $tmp
1946 echo '' >> $tmp
1947 if ! wine regedit $tmp > /dev/null 2>&1; then
1948 rm -f $tmp
1949 echo " failed to load registry changes (path)."
1950 fail
1951 fi
1952 rm -f $tmp
1953 log_success "found"
1954}
1955
1956
1957#
1958# Check for gSOAP.
1959#
1960check_gsoap()
1961{
1962 test_header "GSOAP compiler"
1963 if [ -z "$GSOAP" ]; then
1964 GSOAP="/usr"
1965 fi
1966 if which_wrapper "$GSOAP/bin/soapcpp2" > /dev/null; then
1967 if which_wrapper "$GSOAP/bin/wsdl2h" > /dev/null; then
1968 if [ -f "$GSOAP/include/stdsoap2.h" ]; then
1969 # TODO: Check for libgsoap++.a/so
1970
1971 if [ -z "$GSOAP_IMPORT" ]; then
1972 GSOAP_IMPORT="$GSOAP/share/gsoap/import"
1973 if [ ! -d "$GSOAP_IMPORT" -a -d "$GSOAP/include/gsoap" ]; then
1974 GSOAP_IMPORT="$GSOAP/include/gsoap"
1975 fi
1976 fi
1977 if [ -f "$GSOAP_IMPORT/stlvector.h" ]; then
1978 cnf_append "VBOX_GSOAP_INSTALLED" "1"
1979 cnf_append "VBOX_PATH_GSOAP" "$GSOAP"
1980 cnf_append "VBOX_PATH_GSOAP_IMPORT" "$GSOAP_IMPORT"
1981 if [ -f "$GSOAP/share/gsoap/stdsoap2.cpp" ]; then
1982 cnf_append "VBOX_GSOAP_CXX_SOURCES" "$GSOAP/share/gsoap/stdsoap2.cpp"
1983 else
1984 cnf_append "VBOX_GSOAP_CXX_SOURCES" ""
1985 fi
1986 cnf_append "VBOX_GSOAP_CXX_LIBS" "libgsoap++"
1987 log_success "found"
1988 else
1989 log_failure "stlvector.h not found -- disabling webservice"
1990 cnf_append "VBOX_WITH_WEBSERVICES" ""
1991 fi
1992 else
1993 log_failure "stdsoap2.h not found -- disabling webservice"
1994 cnf_append "VBOX_WITH_WEBSERVICES" ""
1995 fi
1996 else
1997 log_failure "wsdl2h not found -- disabling webservice"
1998 cnf_append "VBOX_WITH_WEBSERVICES" ""
1999 fi
2000 else
2001 log_failure "soapcpp2 not found -- disabling webservice"
2002 cnf_append "VBOX_WITH_WEBSERVICES" ""
2003 fi
2004}
2005
2006
2007#
2008# Determines the Darwin version.
2009# @todo This should really check the Xcode/SDK version.
2010#
2011check_darwinversion()
2012{
2013 test_header "Darwin version"
2014 darwin_ver=`uname -r`
2015 case "$darwin_ver" in
2016 10\.*)
2017 darwin_ver="10.6"
2018 sdk=/Developer/SDKs/MacOSX10.5.sdk
2019 CXX_FLAGS="-mmacosx-version-min=10.5 -isysroot $sdk -Wl,-syslibroot,$sdk"
2020# test "$CC" = "gcc" && CC="gcc-4.0"
2021# test "$CXX" = "g++" && CXX="g++-4.0"
2022 cnf_append "VBOX_MACOS_10_5_WORKAROUND" "1"
2023 ;;
2024 9\.*)
2025 darwin_ver="10.5"
2026 sdk=/Developer/SDKs/MacOSX10.5.sdk
2027 CXX_FLAGS="-mmacosx-version-min=10.5 -isysroot $sdk -Wl,-syslibroot,$sdk"
2028# test "$CC" = "gcc" && CC="gcc-4.0"
2029# test "$CXX" = "g++" && CXX="g++-4.0"
2030 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_6" "1"
2031 cnf_append "VBOX_MACOS_10_5_WORKAROUND" "1"
2032 ;;
2033 8\.*)
2034 darwin_ver="10.4"
2035 sdk=/Developer/SDKs/MacOSX10.4u.sdk
2036 CXX_FLAGS="-mmacosx-version-min=10.4 -isysroot $sdk -Wl,-syslibroot,$sdk"
2037# test "$CC" = "gcc" && CC="gcc-4.0"
2038# test "$CXX" = "g++" && CXX="g++-4.0"
2039 cnf_append "VBOX_WITH_COCOA_QT" ""
2040 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_6" "1"
2041 ;;
2042 *)
2043 echo " failed to determine Darwin version. (uname -r: $darwin_ver)"
2044 fail
2045 darwin_ver="unknown"
2046 ;;
2047 esac
2048 log_success "found version $darwin_ver (SDK: $sdk)"
2049}
2050
2051
2052check_makeself()
2053{
2054 test_header "makeself"
2055 if check_avail "$MAKESELF" makeself; then
2056 makeself_ver=`$MAKESELF --version|grep version|sed 's+^Makeself.*version \([0-9\.]*\).*+\1+'`
2057 if [ $? -ne 0 ]; then
2058 log_failure "not found"
2059 fail
2060 else
2061 log_success "found version $makeself_ver"
2062 cnf_append "VBOX_MAKESELF" "`which_wrapper $MAKESELF`"
2063 fi
2064 fi
2065}
2066
2067
2068#
2069# Checks that i386-elf-gcc-3.4.6, i386-elf-gcc-3.4.3, i386-elf-gcc-3.4 or i386-elf-gcc
2070# is around to prevent confusion when the build fails in src/recompiler.
2071# Note. Keep the which order in sync with the $(which ) in src/recompiler/Makefile.kmk.
2072#
2073check_i386elfgcc()
2074{
2075 test_header "i386-elf-gcc"
2076 i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4.6`
2077 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4.3`
2078 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4`
2079 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc`
2080 if test -z "$i386_elf_gcc"; then
2081 echo " failed to find i386-elf-gcc"
2082 fail
2083 fi
2084 log_success "found $i386_elf_gcc"
2085}
2086
2087
2088#
2089# Show help
2090#
2091show_help()
2092{
2093cat << EOF
2094Usage: ./configure [OPTIONS]...
2095
2096Configuration:
2097 -h, --help display this help and exit
2098 --nofatal don't abort on errors
2099EOF
2100[ $WITH_XPCOM -eq 1 ] && echo " --disable-xpcom disable XPCOM and related stuff"
2101[ $WITH_PYTHON -eq 1 ] && echo " --disable-python disable python bindings"
2102[ $WITH_JAVA -eq 1 ] && echo " --disable-java disable java bindings"
2103[ $WITH_VMMRAW -eq 1 ] && echo " --disable-vmmraw disable VMM raw mode (VT-x/AMD-V mandatory!)"
2104[ $WITH_SDL_TTF -eq 1 ] && echo " --disable-sdl-ttf disable SDL_ttf detection"
2105[ $WITH_ALSA -eq 1 ] && echo " --disable-alsa disable the ALSA sound backend"
2106[ $WITH_PULSE -eq 1 ] && echo " --disable-pulse disable the PulseAudio backend"
2107[ $WITH_DBUS -eq 1 ] && echo " --disable-dbus don't use DBus and hal for hardware detection"
2108[ $WITH_KMODS -eq 1 ] && echo " --disable-kmods don't build Linux kernel modules (host and guest)"
2109[ $WITH_OPENGL -eq 1 ] && echo " --disable-opengl disable OpenGL support (2D & 3D)"
2110[ $WITH_GSOAP -eq 0 ] && echo " --enable-webservice enable the webservice stuff"
2111[ $WITH_DOCS -eq 1 ] && echo " --disable-docs don't build the documentation"
2112[ "$OS" = "linux" -o "$OS" = "freebsd" ] && echo " --enable-vde enable VDE networking"
2113cat << EOF
2114 --disable-hardening don't be strict about /dev/vboxdrv access
2115 --build-libxml2 build libxml2 from sources
2116 --build-libxslt build libxslt from sources
2117EOF
2118[ $OSE -eq 0 ] && cat << EOF
2119 --build-libssl build openssl from sources
2120 --build-libcurl build libcurl from sources
2121EOF
2122[ "$OS" != "darwin" ] && echo " --setup-wine setup a Wine directory and register the hhc hack"
2123cat << EOF
2124
2125Paths:
2126 --with-gcc=PATH location of the gcc compiler [$CC]
2127 --with-g++=PATH location of the g++ compiler [$CXX]
2128 --with-kbuild=DIR kbuild directory [$KBUILDDIR]
2129 --with-iasl=PATH location of the iasl compiler [$IASL]
2130 --with-mkisofs=PATH location of mkisofs [$MKISOFS]
2131EOF
2132[ "$OS" = "linux" ] && echo " --with-linux=DIR Linux kernel source directory [$LINUX]"
2133[ $WITH_QT4 -eq 1 ] && echo " --with-qt-dir=DIR directory for Qt4 headers/libraries [pkgconfig]"
2134[ $WITH_GSOAP -eq 1 ] && echo " --with-gsoap-dir=PATH directory for gSOAP compiler/headers/libraries"
2135[ $WITH_GSOAP -eq 1 ] && echo " (soapcpp2 and wsdl2h, soapstd2.h, libgsoap++.a/so)"
2136[ $WITH_GSOAP -eq 1 ] && echo " --with-gsoap-import=PATH directory for gSOAP import files (stlvector.h)"
2137cat << EOF
2138 --with-openssl-dir=DIR directory for OpenSSL headers/libraries
2139 --out-path=PATH the folder to which configuration and build output
2140 should go
2141
2142Build type:
2143 -d, --build-debug build with debugging symbols and assertions
2144 --build-profile build with profiling support
2145 --build-headless build headless (without any GUI frontend)
2146EOF
2147 exit 0
2148}
2149
2150
2151#
2152# The body.
2153#
2154
2155# test if we are OSE
2156if [ $OSE -eq 1 -a -r "`cd \`dirname $0\`; pwd`/src/VBox/RDP/server/server.cpp" ]; then
2157 OSE=0
2158 # Set this as a reminder to print a log message once we know the path of the
2159 # log file
2160 NOT_OSE=1
2161fi
2162
2163# Change OS specific defaults; must be before all other stuff
2164if [ "$OS" = "darwin" ]; then
2165 WITH_SDL=0
2166 WITH_SDL_TTF=0
2167 WITH_X11=0
2168 WITH_ALSA=0
2169 WITH_PULSE=0
2170 WITH_DBUS=0
2171 WITH_KMODS=0
2172 BUILD_LIBXSLT=1
2173 BUILD_LIBXML2=1
2174 [ $OSE -eq 1 ] || BUILD_LIBCURL=1
2175 [ $OSE -eq 1 ] || BUILD_LIBSSL=1
2176fi
2177
2178
2179# scan command line options
2180for option in $*; do
2181 case "$option" in
2182 --help|-help|-h)
2183 show_help
2184 ;;
2185 --nofatal)
2186 nofatal=1
2187 ;;
2188 --env-only)
2189 ENV_ONLY=1
2190 ;;
2191 --with-gcc=*)
2192 CC=`echo $option | cut -d'=' -f2`
2193 ;;
2194 --with-g++=*)
2195 CXX=`echo $option | cut -d'=' -f2`
2196 ;;
2197 --with-kbuild=*)
2198 KBUILDDIR=`echo $option | cut -d'=' -f2`
2199 if echo $KBUILDDIR|grep -q "$INVALID_CHARS"; then
2200 echo "Error: KBUILDDIR contains invalid characters!"
2201 exit 1
2202 fi
2203 ;;
2204 --with-qt-dir=*|--with-qt4-dir=*)
2205 QT4DIR=`echo $option | cut -d'=' -f2`
2206 QT4DIR_PKGCONFIG=0
2207 ;;
2208 --with-openssl-dir=*)
2209 OPENSSLDIR=`echo $option | cut -d'=' -f2`
2210 INCCRYPTO="-I${OPENSSLDIR}/include"
2211 LIBCRYPTO="${OPENSSLDIR}/lib/libcrypto.a"
2212 ;;
2213 --with-gsoap-dir=*)
2214 GSOAP=`echo $option | cut -d'=' -f2`
2215 ;;
2216 --with-gsoap-import=*)
2217 GSOAP_IMPORT=`echo $option | cut -d'=' -f2`
2218 ;;
2219 --with-iasl=*)
2220 IASL=`echo $option | cut -d'=' -f2`
2221 ;;
2222 --with-linux=*)
2223 LINUX=`echo $option | cut -d'=' -f2`
2224 ;;
2225 --with-mkisofs=*)
2226 MKISOFS=`echo $option | cut -d'=' -f2`
2227 ;;
2228 --target-arch=*)
2229 TARGET_MACHINE=`echo $option | cut -d'=' -f2`
2230 ;;
2231 --disable-xpcom)
2232 [ $WITH_XPCOM -eq 1 ] && WITH_XPCOM=0
2233 ;;
2234 --disable-python)
2235 [ $WITH_PYTHON -eq 1 ] && WITH_PYTHON=0
2236 ;;
2237 --disable-java)
2238 [ $WITH_JAVA -eq 1 ] && WITH_JAVA=0
2239 ;;
2240 --disable-vmmraw)
2241 [ $WITH_VMMRAW -eq 1 ] && WITH_VMMRAW=0
2242 ;;
2243 --disable-sdl-ttf)
2244 [ $WITH_SDL_TTF -eq 1 ] && WITH_SDL_TTF=0
2245 ;;
2246 --disable-qt)
2247 [ $WITH_QT4 -eq 1 ] && WITH_QT4=0
2248 ;;
2249 --disable-qt4)
2250 [ $WITH_QT4 -eq 1 ] && WITH_QT4=0
2251 ;;
2252 --passive-mesa)
2253 PASSIVE_MESA=1
2254 ;;
2255 --disable-alsa)
2256 [ $WITH_ALSA -eq 1 ] && WITH_ALSA=0
2257 ;;
2258 --disable-pulse)
2259 [ $WITH_PULSE -eq 1 ] && WITH_PULSE=0
2260 ;;
2261 --enable-pulse)
2262 WITH_PULSE=2
2263 ;;
2264 --disable-dbus)
2265 [ $WITH_DBUS -eq 1 ] && WITH_DBUS=0
2266 ;;
2267 --disable-kmods)
2268 [ $WITH_KMODS -eq 1 ] && WITH_KMODS=0
2269 ;;
2270 --disable-opengl)
2271 [ $WITH_OPENGL -eq 1 ] && WITH_OPENGL=0
2272 ;;
2273 --enable-webservice)
2274 [ $WITH_GSOAP -eq 0 ] && WITH_GSOAP=1
2275 ;;
2276 --disable-hardening)
2277 WITH_HARDENING=0
2278 ;;
2279 --disable-docs)
2280 WITH_DOCS=0
2281 ;;
2282 --enable-hardening)
2283 WITH_HARDENING=2
2284 ;;
2285 --enable-vde)
2286 WITH_VDE=1
2287 ;;
2288 --build-debug|-d)
2289 BUILD_TYPE=debug
2290 ;;
2291 --build-profile)
2292 BUILD_TYPE=profile
2293 ;;
2294 --build-libxml2)
2295 BUILD_LIBXML2=1
2296 ;;
2297 --build-libxslt)
2298 BUILD_LIBXSLT=1
2299 ;;
2300 --build-libssl)
2301 BUILD_LIBSSL=1
2302 ;;
2303 --build-libcurl)
2304 BUILD_LIBCURL=1
2305 ;;
2306 --build-headless)
2307 HEADLESS=1
2308 WITH_SDL=0
2309 WITH_SDL_TTF=0
2310 WITH_X11=0
2311 WITH_OPENGL=0
2312 WITH_QT4=0
2313 ;;
2314 --ose)
2315 OSE=2
2316 ;;
2317 --odir=*)
2318 ODIR="`echo $option | cut -d'=' -f2`/"
2319 ODIR_OVERRIDE=1
2320 ;;
2321 --out-path=*)
2322 out_path="`echo $option | cut -d'=' -f2`/"
2323 if [ -d $out_path ]; then
2324 saved_path="`pwd`"
2325 cd $out_path
2326 OUT_PATH="`pwd`"
2327 cd $saved_path
2328 OUT_PATH_OVERRIDE=1
2329 if [ $ODIR_OVERRIDE -eq 0 ]; then
2330 # This variable has not *yet* been overridden. That can still happen.
2331 ODIR=$OUT_PATH/
2332 fi
2333 else
2334 echo "Error: invalid folder \"$out_path\" in option \"$option\""
2335 exit 1
2336 fi
2337 ;;
2338 --setup-wine)
2339 [ "$OS" != "darwin" ] && SETUP_WINE=1
2340 ;;
2341 *)
2342 echo
2343 echo "Unrecognized option \"$option\""
2344 echo
2345 show_help
2346 ;;
2347 esac
2348done
2349
2350LOG="$ODIR$LOG"
2351ENV="$ODIR$ENV"
2352CNF="$ODIR$CNF"
2353
2354# initialize output files
2355cat > $LOG << EOF
2356# Log file generated by
2357#
2358# '$0 $*'
2359#
2360
2361EOF
2362cat > $CNF << EOF
2363# -*- Makefile -*-
2364#
2365# automatically generated by
2366#
2367# '$0 $*'
2368#
2369# It will be completely overwritten if configure is executed again.
2370#
2371
2372EOF
2373cat > $ENV << EOF
2374#!/bin/bash
2375#
2376# automatically generated by
2377#
2378# '$0 $*'
2379#
2380# It will be completely overwritten if configure is executed again.
2381# Make sure you source this file once before you start to build VBox.
2382#
2383
2384EOF
2385
2386# Print log warning about OSE if necessary
2387if [ -n "$NOT_OSE" ]; then
2388 echo "Found RDP server, assuming VBOX_OSE = FALSE" >> $LOG
2389 echo >> $LOG
2390fi
2391
2392
2393if [ "$BUILD_TYPE" = "debug" ]; then
2394 echo "Creating DEBUG build!" >> $LOG
2395elif [ "$BUILD_TYPE" = "profile" ]; then
2396 echo "Creating PROFILE build!" >> $LOG
2397fi
2398
2399# first determine our environment
2400check_environment
2401check_kbuild
2402
2403[ -n "$ENV_ONLY" ] && exit 0
2404
2405# append the tools directory to the default search path
2406echo "$PATH" | grep -q "$DEVDIR_BIN" || PATH="$PATH:$DEVDIR_BIN"
2407export PATH
2408
2409# if we will be writing to a different out directory then set this up now
2410if [ $OUT_PATH_OVERRIDE -eq 1 ]; then
2411 echo "AUTOCFG=$OUT_PATH/AutoConfig.kmk" >> $ENV
2412 echo "export AUTOCFG" >> $ENV
2413 echo "LOCALCFG=$OUT_PATH/LocalConfig.kmk" >> $ENV
2414 echo "export LOCALCFG" >> $ENV
2415 echo "PATH_OUT_BASE=$OUT_PATH" >> $ENV
2416 echo "export PATH_OUT_BASE" >> $ENV
2417fi
2418
2419# some things are not available in for OSE
2420if [ $OSE -ge 1 ]; then
2421 cnf_append "VBOX_OSE" "1"
2422 cnf_append "VBOX_WITH_TESTSUITE" ""
2423 cnf_append "VBOX_WITH_WIN32_ADDITIONS" ""
2424
2425 if [ "$OS" = "linux" ]; then
2426 cnf_append "VBOX_WITH_LINUX_ADDITIONS" "1"
2427 else
2428 cnf_append "VBOX_WITH_LINUX_ADDITIONS" ""
2429 fi
2430 echo >> $CNF
2431fi
2432
2433# headless
2434if [ -n "$HEADLESS" ]; then
2435 cnf_append "VBOX_HEADLESS" "1"
2436fi
2437
2438# emit disable directives corresponding to any --disable-xxx options.
2439if [ $WITH_OPENGL -eq 0 ]; then
2440 cnf_append "VBOX_WITH_CROGL" ""
2441 cnf_append "VBOX_WITH_VIDEOHWACCEL" ""
2442 cnf_append "VBOX_GUI_USE_QGL" ""
2443fi
2444[ $WITH_XPCOM -eq 0 ] && cnf_append "VBOX_WITH_MAIN" ""
2445[ $WITH_QT4 -eq 0 ] && cnf_append "VBOX_WITH_QTGUI" ""
2446[ $WITH_SDL_TTF -eq 0 ] && cnf_append "VBOX_WITH_SECURELABEL" ""
2447[ $WITH_PYTHON -eq 0 ] && cnf_append "VBOX_WITH_PYTHON" ""
2448[ $WITH_JAVA -eq 0 ] && cnf_append "VBOX_WITH_JXPCOM" ""
2449[ $WITH_HARDENING -eq 0 ] && cnf_append "VBOX_WITHOUT_HARDENING" "1"
2450[ $WITH_HARDENING -eq 2 ] && cnf_append "VBOX_WITH_HARDENING" "2"
2451[ $WITH_VMMRAW -eq 0 ] && cnf_append "VBOX_WITH_RAW_MODE" ""
2452
2453# Darwin-specific
2454if [ "$OS" = "darwin" ]; then
2455 check_darwinversion
2456fi
2457# the tools
2458check_gcc
2459[ "$OS" != "darwin" ] && check_as86
2460[ "$OS" != "darwin" ] && check_bcc
2461[ "$OS" != "darwin" ] && check_iasl
2462# don't check for yasm for the time beeing as 0.40 and 0.50 both have known bugs
2463# [ "$OS" != "darwin" ] && check_yasm
2464[ "$OS" != "darwin" ] && check_xsltproc
2465[ "$OS" != "darwin" ] && check_mkisofs
2466
2467# the libraries
2468[ "$OS" != "darwin" ] && check_pthread
2469check_libxml2
2470[ $WITH_XPCOM -eq 1 ] && check_libxslt
2471[ $WITH_LIBIDL -eq 1 ] && check_libidl
2472check_ssl
2473check_curl
2474[ "$OS" != "darwin" ] && check_z
2475[ "$OS" != "darwin" ] && check_png
2476[ $OSE -eq 0 -a "$OS" = "linux" ] && check_pam
2477[ $WITH_SDL -eq 1 ] && check_sdl
2478[ $WITH_SDL_TTF -eq 1 -a $OSE -eq 0 ] && check_sdl_ttf
2479[ $WITH_X11 -eq 1 ] && check_x
2480# TODO check for xcomposite-dev (X11/extensions/Xcomposite.h, additions only)
2481# TODO check for libxdamange-dev (X11/extensions/Xdamage.h, additions only)
2482[ $WITH_X11 -eq 1 ] && check_xcursor
2483[ $WITH_X11 -eq 1 ] && check_xinerama
2484[ $WITH_X11 -eq 1 ] && check_xrandr
2485[ $WITH_OPENGL -eq 1 ] && check_opengl
2486[ $WITH_QT4 -eq 1 ] && check_qt4
2487[ $WITH_PYTHON -eq 1 ] && check_python
2488[ $WITH_JAVA -eq 1 ] && check_java
2489
2490# PulseAudio
2491if [ "$OS" = "linux" -o "$OS" = "freebsd" ]; then
2492 if [ $WITH_PULSE -eq 1 ]; then
2493 check_pulse
2494 elif [ $WITH_PULSE -eq 0 ]; then
2495 cnf_append "VBOX_WITH_PULSE" ""
2496 fi
2497fi
2498
2499# Linux-specific
2500if [ "$OS" = "linux" ]; then
2501 # don't check for the static libstdc++ in the PUEL version as we build the
2502 # additions at a dedicated box
2503 [ $OSE -ge 1 ] && check_staticlibstdcxx
2504 if [ $WITH_KMODS -eq 1 ]; then
2505 check_linux
2506 else
2507 cnf_append "VBOX_LINUX_SRC" ""
2508 cnf_append "VBOX_WITH_VBOXDRV" ""
2509 cnf_append "VBOX_WITH_ADDITION_DRIVERS" ""
2510 fi
2511 if [ $WITH_ALSA -eq 1 ]; then
2512 check_alsa
2513 else
2514 cnf_append "VBOX_WITH_ALSA" ""
2515 fi
2516 if [ $WITH_DBUS -eq 0 ]; then
2517 cnf_append "VBOX_WITH_DBUS" ""
2518 fi
2519 check_libcap
2520 check_compiler_h
2521 [ "$BUILD_MACHINE" = "amd64" -a $WITH_VMMRAW -eq 1 ] && check_32bit
2522 # tools/common/makeself*
2523 [ $OSE -ge 1 ] && check_makeself
2524fi
2525
2526[ -n "$SETUP_WINE" ] && setup_wine
2527
2528if [ $OSE -ge 1 ]; then
2529 if [ $WITH_GSOAP -eq 1 ]; then
2530 check_gsoap
2531 else
2532 cnf_append "VBOX_WITH_WEBSERVICES" ""
2533 fi
2534fi
2535
2536# VDE
2537if [ "$OS" = "linux" -o "$OS" = "freebsd" ]; then
2538 if [ $WITH_VDE -eq 1 ]; then
2539 cnf_append "VBOX_WITH_VDE" "1"
2540 fi
2541fi
2542
2543# DOCS
2544if [ $WITH_DOCS -eq 0 ]; then
2545 cnf_append "VBOX_WITH_DOCS" ""
2546 cnf_append "VBOX_WITH_DOCS_PACKING" ""
2547fi
2548
2549# success!
2550echo
2551echo "Successfully generated '$CNF' and '$ENV'."
2552echo "Source '$ENV' once before you start to build VBox:"
2553echo ""
2554echo " source $ENV"
2555echo " kmk"
2556echo ""
2557if [ "$OS" = "linux" ]; then
2558 if [ $OUT_PATH_OVERRIDE -eq 1 ]; then
2559 vbox_out_path=$OUT_PATH
2560 else
2561 vbox_out_path=./out
2562 fi
2563 echo "To compile the kernel modules, do:"
2564 echo ""
2565 echo " cd $vbox_out_path/$OS.$TARGET_MACHINE/$BUILD_TYPE/bin/src"
2566 echo " make"
2567 echo ""
2568fi
2569if [ $WITH_HARDENING -gt 0 ]; then
2570 echo ""
2571 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2572 echo " Hardening is enabled which means that the VBox binaries will not run from"
2573 echo " the binary directory. The binaries have to be installed suid root and some"
2574 echo " more prerequisites have to be fulfilled which is normally done by installing"
2575 echo " the final package. For development, the hardening feature can be disabled"
2576 echo " by specifying the --disable-hardening parameter. Please never disable that"
2577 echo " feature for the final distribution!"
2578 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2579 echo ""
2580else
2581 echo ""
2582 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2583 echo " Hardening is disabled. Please do NOT build packages for distribution with"
2584 echo " disabled hardening!"
2585 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2586 echo ""
2587fi
2588echo "Enjoy!"
2589cleanup
Note: See TracBrowser for help on using the repository browser.

© 2023 Oracle
ContactPrivacy policyTerms of Use